package goap

type MastoDevicesData struct {
	FullIdType
}

func (actor *MastoDevicesData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoDevicesData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_DEVICES)
}

type MastoDiscoverableData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *MastoDiscoverableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoDiscoverableData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_DISCOVERABLE,
		[]map[string]any{namedata.Value.Marshal()},
	)
}

type MastoFeaturedData struct {
	FullIdType
}

func (actor *MastoFeaturedData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoFeaturedData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED)
}

type MastoFeaturedTagsData struct {
	FullIdType
}

func (actor *MastoFeaturedTagsData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoFeaturedTagsData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED_TAGS)
}

type MastoIndexableData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *MastoIndexableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoIndexableData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_INDEXABLE,
		[]map[string]any{namedata.Value.Marshal()},
	)
}

type MastoMemorialData struct {
	Next  BaseApChain
	Value ValueValue[bool]
}

func (namedata *MastoMemorialData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoMemorialData) MarshalToMap() map[string]any {
	return appendWithKey(
		namedata.Next.MarshalToMap(),
		KEY_MASTO_MEMORIAL,
		[]map[string]any{namedata.Value.Marshal()},
	)
}
